- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- Alphabetical List
- Data Structures
- Class Hierarchy
- Data Fields

# SimpleDateFormat Class Reference

SimpleDateFormat is a concrete class for formatting and parsing dates in a language-independent manner. More...

`#include <smpdtfmt.h>`

Inheritance diagram for SimpleDateFormat:

## Public Member Functions
| SimpleDateFormat (UErrorCode &status)
| Construct a SimpleDateFormat using the default pattern for the default locale.
| SimpleDateFormat (const UnicodeString &pattern, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and the default locale.
| SimpleDateFormat (const UnicodeString &pattern, const Locale &locale, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and locale.
| SimpleDateFormat (const UnicodeString &pattern, DateFormatSymbols *formatDataToAdopt, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.
| SimpleDateFormat (const UnicodeString &pattern, const DateFormatSymbols &formatData, UErrorCode &status)
| Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.
| SimpleDateFormat (const SimpleDateFormat &)
| Copy constructor.
SimpleDateFormat & | operator= (const SimpleDateFormat &)
| Assignment operator.
virtual | ~SimpleDateFormat ()
| Destructor.
virtual Format * | clone (void) const
| Clone this Format object polymorphically.
virtual UBool | operator== (const Format &other) const
| Return true if the given Format objects are semantically equal.
virtual UnicodeString & | format (Calendar &cal, UnicodeString &appendTo, FieldPosition &pos) const
| Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.
virtual UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const
| Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.
UnicodeString & | format (UDate date, UnicodeString &appendTo, FieldPosition &fieldPosition) const
| Redeclared DateFormat method.
UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Redeclared DateFormat method.
UnicodeString & | format (UDate date, UnicodeString &appendTo) const
| Redeclared DateFormat method.
virtual void | parse (const UnicodeString &text, Calendar &cal, ParsePosition &pos) const
| Parse a date/time string beginning at the given parse position.
UDate | parse (const UnicodeString &text, ParsePosition &pos) const
| Parse a date/time string starting at the given parse position.
virtual UDate | parse (const UnicodeString &text, UErrorCode &status) const
| Parse a date/time string.
virtual void | set2DigitYearStart (UDate d, UErrorCode &status)
| Set the start UDate used to interpret two-digit year strings.
UDate | get2DigitYearStart (UErrorCode &status) const
| Get the start UDate used to interpret two-digit year strings.
virtual UnicodeString & | toPattern (UnicodeString &result) const
| Return a pattern string describing this date format.
virtual UnicodeString & | toLocalizedPattern (UnicodeString &result, UErrorCode &status) const
| Return a localized pattern string describing this date format.
virtual void | applyPattern (const UnicodeString &pattern)
| Apply the given unlocalized pattern string to this date format.
virtual void | applyLocalizedPattern (const UnicodeString &pattern, UErrorCode &status)
| Apply the given localized pattern string to this date format.
virtual const DateFormatSymbols * | getDateFormatSymbols (void) const
| Gets the date/time formatting symbols (this is an object carrying the various strings and other symbols used in formatting: e.g., month names and abbreviations, time zone names, AM/PM strings, etc.
virtual void | adoptDateFormatSymbols (DateFormatSymbols *newFormatSymbols)
| Set the date/time formatting symbols.
virtual void | setDateFormatSymbols (const DateFormatSymbols &newFormatSymbols)
| Set the date/time formatting data.
virtual UClassID | getDynamicClassID (void) const
| Returns a unique class ID POLYMORPHICALLY.
virtual void | adoptCalendar (Calendar *calendarToAdopt)
| Set the calendar to be used by this date format.
## Static Public Member Functions
static UClassID | getStaticClassID (void)
| Return the class ID for this class.
## Friends
class | DateFormat

## Detailed Description

SimpleDateFormat is a concrete class for formatting and parsing dates in a language-independent manner.

It allows for formatting (millis -> text), parsing (text -> millis), and normalization. Formats/Parses a date or time, which is the standard milliseconds since 24:00 GMT, Jan 1, 1970.

Clients are encouraged to create a date-time formatter using DateFormat::getInstance(), getDateInstance(), getDateInstance(), or getDateTimeInstance() rather than explicitly constructing an instance of SimpleDateFormat. This way, the client is guaranteed to get an appropriate formatting pattern for whatever locale the program is running in. However, if the client needs something more unusual than the default patterns in the locales, he can construct a SimpleDateFormat directly and give it an appropriate pattern (or use one of the factory methods on DateFormat and modify the pattern after the fact with toPattern() and applyPattern().

Date/Time format syntax:

The date/time format is specified by means of a string time pattern. In this pattern, all ASCII letters are reserved as pattern letters, which are defined as the following:

     Symbol   Meaning                 Presentation        Example
     ------   -------                 ------------        -------
     G        era designator          (Text)              AD
     y        year                    (Number)            1996
     Y        year (week of year)     (Number)            1997
     u        extended year           (Number)            4601
     M        month in year           (Text & Number)     July & 07
     d        day in month            (Number)            10
     h        hour in am/pm (1~12)    (Number)            12
     H        hour in day (0~23)      (Number)            0
     m        minute in hour          (Number)            30
     s        second in minute        (Number)            55
     S        fractional second       (Number)            978
     E        day of week             (Text)              Tuesday
     e        day of week (local 1~7) (Number)            2
     D        day in year             (Number)            189
     F        day of week in month    (Number)            2 (2nd Wed in July)
     w        week in year            (Number)            27
     W        week in month           (Number)            2
     a        am/pm marker            (Text)              PM
     k        hour in day (1~24)      (Number)            24
     K        hour in am/pm (0~11)    (Number)            0
     z        time zone               (Time)              Pacific Standard Time
     Z        time zone (RFC 822)     (Number)            -0800
     v        time zone (generic)     (Text)              Pacific Time
     g        Julian day              (Number)            2451334
     A        milliseconds in day     (Number)            69540000
     '        escape for text         (Delimiter)         'Date='
     ''       single quote            (Literal)           'o''clock'

The count of pattern letters determine the format.

(Text): 4 or more, use full form, <4, use short or abbreviated form if it exists. (e.g., "EEEE" produces "Monday", "EEE" produces "Mon")

(Number): the minimum number of digits. Shorter numbers are zero-padded to this amount (e.g. if "m" produces "6", "mm" produces "06"). Year is handled specially; that is, if the count of 'y' is 2, the Year will be truncated to 2 digits. (e.g., if "yyyy" produces "1997", "yy" produces "97".) Unlike other fields, fractional seconds are padded on the right with zero.

(Text & Number): 3 or over, use text, otherwise use number. (e.g., "M" produces "1", "MM" produces "01", "MMM" produces "Jan", and "MMMM" produces "January".)

Any characters in the pattern that are not in the ranges of ['a'..'z'] and ['A'..'Z'] will be treated as quoted text. For instance, characters like ':', '.', ' ', '#' and '@' will appear in the resulting time text even they are not embraced within single quotes.

A pattern containing any invalid pattern letter will result in a failing UErrorCode result during formatting or parsing.

Examples using the US locale:

        Format Pattern                         Result
        --------------                         -------
        "yyyy.MM.dd G 'at' HH:mm:ss vvvv" ->>  1996.07.10 AD at 15:08:56 Pacific Time
        "EEE, MMM d, ''yy"                ->>  Wed, July 10, '96
        "h:mm a"                          ->>  12:08 PM
        "hh 'o''clock' a, zzzz"           ->>  12 o'clock PM, Pacific Daylight Time
        "K:mm a, vvv"                     ->>  0:00 PM, PT
        "yyyyy.MMMMM.dd GGG hh:mm aaa"    ->>  1996.July.10 AD 12:08 PM

Code Sample:

         UErrorCode success = U_ZERO_ERROR;
         SimpleTimeZone* pdt = new SimpleTimeZone(-8 * 60 * 60 * 1000, "PST");
         pdt->setStartRule( Calendar::APRIL, 1, Calendar::SUNDAY, 2*60*60*1000);
         pdt->setEndRule( Calendar::OCTOBER, -1, Calendar::SUNDAY, 2*60*60*1000);

         // Format the current time.
         SimpleDateFormat* formatter
             = new SimpleDateFormat ("yyyy.MM.dd G 'at' hh:mm:ss a zzz", success );
         GregorianCalendar cal(success);
         UDate currentTime_1 = cal.getTime(success);
         FieldPosition fp(0);
         UnicodeString dateString;
         formatter->format( currentTime_1, dateString, fp );
         cout << "result: " << dateString << endl;

         // Parse the previous string back into a Date.
         ParsePosition pp(0);
         UDate currentTime_2 = formatter->parse(dateString, pp );

In the above example, the time value "currentTime_2" obtained from parsing will be equal to currentTime_1. However, they may not be equal if the am/pm marker 'a' is left out from the format pattern while the "hour in am/pm" pattern symbol is used. This information loss can happen when formatting the time in PM.

When parsing a date string using the abbreviated year pattern ("y" or "yy"), SimpleDateFormat must interpret the abbreviated year relative to some century. It does this by adjusting dates to be within 80 years before and 20 years after the time the SimpleDateFormat instance is created. For example, using a pattern of "MM/dd/yy" and a SimpleDateFormat instance created on Jan 1, 1997, the string "01/11/12" would be interpreted as Jan 11, 2012 while the string "05/04/64" would be interpreted as May 4, 1964. During parsing, only strings consisting of exactly two digits, as defined by `Unicode::isDigit()`, will be parsed into the default century. Any other numeric string, such as a one digit string, a three or more digit string, or a two digit string that isn't all digits (for example, "-1"), is interpreted literally. So "01/02/3" or "01/02/003" are parsed, using the same pattern, as Jan 2, 3 AD. Likewise, "01/02/-3" is parsed as Jan 2, 4 BC.

If the year pattern has more than two 'y' characters, the year is interpreted literally, regardless of the number of digits. So using the pattern "MM/dd/yyyy", "01/11/12" parses to Jan 11, 12 A.D.

When numeric fields abut one another directly, with no intervening delimiter characters, they constitute a run of abutting numeric fields. Such runs are parsed specially. For example, the format "HHmmss" parses the input text "123456" to 12:34:56, parses the input text "12345" to 1:23:45, and fails to parse "1234". In other words, the leftmost field of the run is flexible, while the others keep a fixed width. If the parse fails anywhere in the run, then the leftmost field is shortened by one character, and the entire run is parsed again. This is repeated until either the parse succeeds or the leftmost field is one character in length. If the parse still fails at that point, the parse of the run fails.

For time zones that have no names, SimpleDateFormat uses strings GMT+hours:minutes or GMT-hours:minutes.

The calendar defines what is the first day of the week, the first week of the year, whether hours are zero based or not (0 vs 12 or 24), and the timezone. There is one common number format to handle all the numbers; the digit count is handled programmatically according to the pattern.

User subclasses are not supported. While clients may write subclasses, such code will not necessarily work and will not be guaranteed to work stably from release to release.

Definition at line 206 of file smpdtfmt.h.

## Constructor & Destructor Documentation

SimpleDateFormat::SimpleDateFormat | ( | UErrorCode & | status | ) |

Construct a SimpleDateFormat using the default pattern for the default locale.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters:

  | status | Output param set to success/failure code.

Stable:
  ICU 2.0

SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status |
| ) |  |  |

Construct a SimpleDateFormat using the given pattern and the default locale.

The locale is used to obtain the symbols used in formatting (e.g., the names of the months), but not to provide the pattern.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters:

  | pattern | the pattern for the format.
  | status | Output param set to success/failure code.

Stable:
  ICU 2.0

SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | const Locale & | locale,
|  | UErrorCode & | status |
| ) |  |  |

Construct a SimpleDateFormat using the given pattern and locale.

The locale is used to obtain the symbols used in formatting (e.g., the names of the months), but not to provide the pattern.

[Note:] Not all locales support SimpleDateFormat; for full generality, use the factory methods in the DateFormat class.

Parameters:

  | pattern | the pattern for the format.
  | locale | the given locale.
  | status | Output param set to success/failure code.

Stable:
  ICU 2.0

SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | DateFormatSymbols * | formatDataToAdopt,
|  | UErrorCode & | status |
| ) |  |  |

Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.

The formatter takes ownership of the DateFormatSymbols object; the caller is no longer responsible for deleting it.

Parameters:

  | pattern | the given pattern for the format.
  | formatDataToAdopt | the symbols to be adopted.
  | status | Output param set to success/faulure code.

Stable:
  ICU 2.0

SimpleDateFormat::SimpleDateFormat | ( | const UnicodeString & | pattern,
|  | const DateFormatSymbols & | formatData,
|  | UErrorCode & | status |
| ) |  |  |

Construct a SimpleDateFormat using the given pattern and locale-specific symbol data.

The DateFormatSymbols object is NOT adopted; the caller remains responsible for deleting it.

Parameters:

  | pattern | the given pattern for the format.
  | formatData | the formatting symbols to be use.
  | status | Output param set to success/faulure code.

Stable:
  ICU 2.0

SimpleDateFormat::SimpleDateFormat | ( | const SimpleDateFormat & |  | ) |

Copy constructor.

Stable:
  ICU 2.0

virtual SimpleDateFormat::~SimpleDateFormat | ( |  | ) | `[virtual]`

Destructor.

Stable:
  ICU 2.0

## Member Function Documentation

SimpleDateFormat& SimpleDateFormat::operator= | ( | const SimpleDateFormat & |  | ) |

Assignment operator.

Stable:
  ICU 2.0

virtual Format* SimpleDateFormat::clone | ( | void |  | ) | const`[virtual]`

Clone this Format object polymorphically.

The caller owns the result and should delete it when done.

Returns:
  A copy of the object.

Stable:
  ICU 2.0

Implements Format.

virtual UBool SimpleDateFormat::operator== | ( | const Format & | other | ) | const`[virtual]`

Return true if the given Format objects are semantically equal.

Objects of different subclasses are considered unequal.

Parameters:

  | other | the object to be compared with.

Returns:
  true if the given Format objects are semantically equal.

Stable:
  ICU 2.0

Reimplemented from DateFormat.

virtual UnicodeString& SimpleDateFormat::format | ( | Calendar & | cal,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos |
| ) |  |  | const`[virtual]`

Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.

Overrides DateFormat pure virtual method.

Example: using the US locale: "yyyy.MM.dd e 'at' HH:mm:ss zzz" ->> 1996.07.10 AD at 15:08:56 PDT

Parameters:

  | cal | Calendar set to the date and time to be formatted into a date/time string.
  | appendTo | Output parameter to receive result. Result is appended to existing contents.
  | pos | The formatting position. On input: an alignment field, if desired. On output: the offsets of the alignment field.

Returns:
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.1

Implements DateFormat.

virtual UnicodeString& SimpleDateFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status |
| ) |  |  | const`[virtual]`

Format a date or time, which is the standard millis since 24:00 GMT, Jan 1, 1970.

Overrides DateFormat pure virtual method.

Example: using the US locale: "yyyy.MM.dd e 'at' HH:mm:ss zzz" ->> 1996.07.10 AD at 15:08:56 PDT

Parameters:

  | obj | A Formattable containing the date-time value to be formatted into a date-time string. If the type of the Formattable is a numeric type, it is treated as if it were an instance of Date.
  | appendTo | Output parameter to receive result. Result is appended to existing contents.
  | pos | The formatting position. On input: an alignment field, if desired. On output: the offsets of the alignment field.
  | status | Output param set to success/faulure code.

Returns:
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

Reimplemented from DateFormat.

UnicodeString & SimpleDateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | fieldPosition |
| ) |  |  | const`[inline]`

Redeclared DateFormat method.

Parameters:

  | date | the Date value to be formatted.
  | appendTo | Output parameter to receive result. Result is appended to existing contents.
  | fieldPosition | The formatting position. On input: an alignment field, if desired. On output: the offsets of the alignment field.

Returns:
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.1

Reimplemented from DateFormat.

Definition at line 878 of file smpdtfmt.h.

References DateFormat::format().

UnicodeString & SimpleDateFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | UErrorCode & | status |
| ) |  |  | const`[inline]`

Redeclared DateFormat method.

Parameters:

  | obj | Object to be formatted.
  | appendTo | Output parameter to receive result. Result is appended to existing contents.
  | status | Input/output success/failure code.

Returns:
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

Reimplemented from DateFormat.

Definition at line 869 of file smpdtfmt.h.

References DateFormat::format().

UnicodeString & SimpleDateFormat::format | ( | UDate | date,
|  | UnicodeString & | appendTo |
| ) |  |  | const`[inline]`

Redeclared DateFormat method.

Parameters:

  | date | Date value to be formatted.
  | appendTo | Output parameter to receive result. Result is appended to existing contents.

Returns:
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

Reimplemented from DateFormat.

Definition at line 887 of file smpdtfmt.h.

References DateFormat::format().

virtual void SimpleDateFormat::parse | ( | const UnicodeString & | text,
|  | Calendar & | cal,
|  | ParsePosition & | pos |
| ) |  |  | const`[virtual]`

Parse a date/time string beginning at the given parse position.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

Parameters:

  | text | The date/time string to be parsed
  | cal | a Calendar set to the date and time to be formatted into a date/time string.
  | pos | On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.

Returns:
  A valid UDate if the input could be parsed.

Stable:
  ICU 2.1

Implements DateFormat.

UDate SimpleDateFormat::parse | ( | const UnicodeString & | text,
|  | ParsePosition & | pos |
| ) |  |  | const

Parse a date/time string starting at the given parse position.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

See also:
  DateFormat::setLenient(boolean)

Parameters:

  | text | The date/time string to be parsed
  | pos | On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.

Returns:
  A valid UDate if the input could be parsed.

Stable:
  ICU 2.0

Reimplemented from DateFormat.

virtual UDate SimpleDateFormat::parse | ( | const UnicodeString & | text,
|  | UErrorCode & | status |
| ) |  |  | const`[virtual]`

Parse a date/time string.

For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a UDate that is equivalent to Date(837039928046). Parsing begins at the beginning of the string and proceeds as far as possible. Assuming no parse errors were encountered, this function doesn't return any information about how much of the string was consumed by the parsing. If you need that information, use the version of parse() that takes a ParsePosition.

Parameters:

  | text | The date/time string to be parsed
  | status | Filled in with U_ZERO_ERROR if the parse was successful, and with an error value if there was a parse error.

Returns:
  A valid UDate if the input could be parsed.

Stable:
  ICU 2.0

Reimplemented from DateFormat.

virtual void SimpleDateFormat::set2DigitYearStart | ( | UDate | d,
|  | UErrorCode & | status |
| ) |  |  | `[virtual]`

Set the start UDate used to interpret two-digit year strings.

When dates are parsed having 2-digit year strings, they are placed within a assumed range of 100 years starting on the two digit start date. For example, the string "24-Jan-17" may be in the year 1817, 1917, 2017, or some other year. SimpleDateFormat chooses a year so that the resultant date is on or after the two digit start date and within 100 years of the two digit start date.

By default, the two digit start date is set to 80 years before the current time at which a SimpleDateFormat object is created.

Parameters:

  | d | start UDate used to interpret two-digit year strings.
  | status | Filled in with U_ZERO_ERROR if the parse was successful, and with an error value if there was a parse error.

Stable:
  ICU 2.0

UDate SimpleDateFormat::get2DigitYearStart | ( | UErrorCode & | status | ) | const`[inline]`

Get the start UDate used to interpret two-digit year strings.

When dates are parsed having 2-digit year strings, they are placed within a assumed range of 100 years starting on the two digit start date. For example, the string "24-Jan-17" may be in the year 1817, 1917, 2017, or some other year. SimpleDateFormat chooses a year so that the resultant date is on or after the two digit start date and within 100 years of the two digit start date.

By default, the two digit start date is set to 80 years before the current time at which a SimpleDateFormat object is created.

Parameters:

  | status | Filled in with U_ZERO_ERROR if the parse was successful, and with an error value if there was a parse error.

Stable:
  ICU 2.0

Definition at line 863 of file smpdtfmt.h.

virtual UnicodeString& SimpleDateFormat::toPattern | ( | UnicodeString & | result | ) | const`[virtual]`

Return a pattern string describing this date format.

Parameters:

  | result | Output param to receive the pattern.

Returns:
  A reference to 'result'.

Stable:
  ICU 2.0

virtual UnicodeString& SimpleDateFormat::toLocalizedPattern | ( | UnicodeString & | result,
|  | UErrorCode & | status |
| ) |  |  | const`[virtual]`

Return a localized pattern string describing this date format.

In most cases, this will return the same thing as toPattern(), but a locale can specify characters to use in pattern descriptions in place of the ones described in this class's class documentation. (Presumably, letters that would be more mnemonic in that locale's language.) This function would produce a pattern using those letters.

Parameters:

  | result | Receives the localized pattern.
  | status | Output param set to success/failure code on exit. If the pattern is invalid, this will be set to a failure result.

Returns:
  A reference to 'result'.

Stable:
  ICU 2.0

virtual void SimpleDateFormat::applyPattern | ( | const UnicodeString & | pattern | ) | `[virtual]`

Apply the given unlocalized pattern string to this date format.

(i.e., after this call, this formatter will format dates according to the new pattern)

Parameters:

  | pattern | The pattern to be applied.

Stable:
  ICU 2.0

virtual void SimpleDateFormat::applyLocalizedPattern | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status |
| ) |  |  | `[virtual]`

Apply the given localized pattern string to this date format.

(see toLocalizedPattern() for more information on localized patterns.)

Parameters:

  | pattern | The localized pattern to be applied.
  | status | Output param set to success/failure code on exit. If the pattern is invalid, this will be set to a failure result.

Stable:
  ICU 2.0

virtual const DateFormatSymbols* SimpleDateFormat::getDateFormatSymbols | ( | void |  | ) | const`[virtual]`

Gets the date/time formatting symbols (this is an object carrying the various strings and other symbols used in formatting: e.g., month names and abbreviations, time zone names, AM/PM strings, etc.

)

Returns:
  a copy of the date-time formatting data associated with this date-time formatter.

Stable:
  ICU 2.0

virtual void SimpleDateFormat::adoptDateFormatSymbols | ( | DateFormatSymbols * | newFormatSymbols | ) | `[virtual]`

Set the date/time formatting symbols.

The caller no longer owns the DateFormatSymbols object and should not delete it after making this call.

Parameters:

  | newFormatSymbols | the given date-time formatting symbols to copy.

Stable:
  ICU 2.0

virtual void SimpleDateFormat::setDateFormatSymbols | ( | const DateFormatSymbols & | newFormatSymbols | ) | `[virtual]`

Set the date/time formatting data.

Parameters:

  | newFormatSymbols | the given date-time formatting symbols to copy.

Stable:
  ICU 2.0

static UClassID SimpleDateFormat::getStaticClassID | ( | void |  | ) | `[static]`

Return the class ID for this class.

This is useful only for comparing to a return value from getDynamicClassID(). For example:

     .   Base* polymorphic_pointer = createPolymorphicObject();
     .   if (polymorphic_pointer->getDynamicClassID() ==
     .       erived::getStaticClassID()) ...

Returns:
  The class ID for all objects of this class.

Stable:
  ICU 2.0

virtual UClassID SimpleDateFormat::getDynamicClassID | ( | void |  | ) | const`[virtual]`

Returns a unique class ID POLYMORPHICALLY.

Pure virtual override. This method is to implement a simple version of RTTI, since not all C++ compilers support genuine RTTI. Polymorphic operator==() and clone() methods call this method.

Returns:
  The class ID for this object. All objects of a given class have the same class ID. Objects of other classes have different class IDs.

Stable:
  ICU 2.0

Implements Format.

virtual void SimpleDateFormat::adoptCalendar | ( | Calendar * | calendarToAdopt | ) | `[virtual]`

Set the calendar to be used by this date format.

Initially, the default calendar for the specified or default locale is used. The caller should not delete the Calendar object after it is adopted by this call. Adopting a new calendar will change to the default symbols.

Parameters:

  | calendarToAdopt | Calendar object to be adopted.

Stable:
  ICU 2.0

Reimplemented from DateFormat.

The documentation for this class was generated from the following file:

- smpdtfmt.h